Smalltalk createPackage: 'Trapped-Counter'!
(Smalltalk packageAt: 'Trapped-Counter') imports: {'trapped/Trapped-Processors'}!
Object subclass: #App
	instanceVariableNames: ''
	package: 'Trapped-Counter'!

!App methodsFor: 'startup'!

start
	| model |
	model := TrappedCounter new.
	model axxord: SimpleAxon new.
	Trapped start: { model }
! !

!App class methodsFor: 'startup'!

start
	^ self new start
! !

Object subclass: #TrappedCounter
	instanceVariableNames: 'value'
	package: 'Trapped-Counter'!

!TrappedCounter methodsFor: 'accessing'!

value
	^value
!

value: aNumber
	value := aNumber
! !

!TrappedCounter methodsFor: 'action'!

decrement
	value := value - 1
!

increment
	value := value + 1
! !

!TrappedCounter methodsFor: 'initialization'!

initialize
	super initialize.
	value := 0
! !

